' -----------------------------------------------------------------------------------------------------------
' ̃Tv́A}ʏɔzuꂽ}iȂl擾\}̂łB
'
' sɂ́A炩߃Tv}"ListUpAttribute.rpcd"JĂB
' ܂́AL̏𖞂}ʂJĂB
' "PRICE"ƂȎli𕶎ɂ́j}i"FLOOR"ƂO̕}ɂ邱ƁB
' śuRootPro CADv[AhC]j[[\̍쐬]Iт܂B
' Copyright 2010 TECHNICAL STAFF Corporation.
' -----------------------------------------------------------------------------------------------------------

Imports System
Imports System.Windows.Forms
Imports System.Collections.Generic
Imports RootPro.RootProCAD
Imports RootPro.RootProCAD.Command
Imports RootPro.RootProCAD.Geometry


Partial Class RootProCADApplication

    Private commandName As String = "\̍쐬" ' R}h
    Private commandResistName As String = "DrawListVB" ' R}h}l[W[o^pR}h

    ''' <summary>
    ''' AhCN̏
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub RootProCADApplication_Startup(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Startup
        ' j[ɃR}hǉ
        Dim mc As MacroCommandCallback = AddressOf Me.MacroCommand
        CommandManager.AddMacroCommand(commandName, mc)

        ' R}h}l[W[ɃR}hǉ '' (R}hEBhEő삷R}hɂȂ܂)
        Dim command As Command = CommandManager.AddCommand(commandResistName) ' R}h}l[W[o^pR}h
        command.Name = commandName ' R}hisɃR}hEBhEɕ\܂j
        ' Wp[^̒ǉ
        Dim parameterGroups As CommandParameterGroupCollection = command.ParameterGroups
        Dim parameterGroup As CommandParameterGroup = parameterGroups.Add(ParameterItemType.Point, 0, "zu_W()")

        ' p[^̕ύXCxgo^
        AddHandler command.ParameterChanged, AddressOf Me.command_ParameterChanged ' Cxg֐:command_ParameterChanged

    End Sub

    ''' <summary>
    ''' AhC̏Ȉ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub RootProCADApplication_Shutdown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shutdown
        ' R}h̍폜(IɕKs)
        CommandManager.RemoveMacroCommand(AddressOf Me.MacroCommand) ' ǉR}h֐

        ' R}h}l[W[ɓo^R}hɍ폜(IɕKs)
        CommandManager.RemoveCommand(commandResistName) ' ǉR}h
    End Sub

    ''' <summary>
    ''' j["\̍쐬"R}hsƂ̏
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub MacroCommand()
        ' R}hs(R}h}l[W[o^pR}hg)
        CommandManager.ExecuteCommand(commandResistName)
    End Sub

    ''' <summary>
    ''' p[^ύXCxg izu_W͂ꂽƂj
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub command_ParameterChanged(ByVal sender As [Object], ByVal e As CommandParameterChangedEventArgs)

        Dim command As Command = CType(sender, Command)
        Dim id As Integer = e.ParameterID ' ύX̂p[^ID
        Dim parameterItem As ParameterItem = command.GetParameterItemByID(id) ' p[^ACe
        ' p[^ACeW^Cv̏ꍇ
        If parameterItem.ParameterType = ParameterItemType.Point Then
            Dim pointParameterItem As PointParameterItem = CType(parameterItem, PointParameterItem)
            Dim point As Point2d = pointParameterItem.Point ' zu_W̎擾
            ' \̍쐬s
            DrawPriceList(point)
        End If

        e.CommandState = CommandState.End ' I

    End Sub

    ''' <summary>
    ''' }ȋgāAWv\쐬܂B
    ''' </summary>
    ''' <param name="point">\̔zu_()</param>
    ''' <remarks></remarks>
    Private Sub DrawPriceList(ByVal point As Point2d)

        Dim doc As Document = ActiveDocument ' ANeBuȐ}ʂ̎擾
        Dim drawings As DrawingCollection = doc.Drawings ' }RNV擾
        Dim drawing As Drawing = drawings("FLOOR") ' "FLOOR"}̐}`Ώۂɂ

        ' FLOOR ȂΏI
        If drawing Is Nothing Then
            MessageBox.Show("}uFROORv܂BTvp̐}ʃt@CJĂB")
            Return
        End If

        ' J[\v
        Cursor.Current = Cursors.WaitCursor

        ' WvpnbVe[u(L[͍}i, lint(,lPRICE̍v)̔z)p
        Dim priceDict As New Dictionary(Of String, Integer())

        '' }̑S}`}i 
        Dim shape As Shape = Nothing
        shape = drawing.Shapes.GetNextShape(shape) ' }ɂŏ̐}`
        While shape IsNot Nothing
            ' }ȉꍇ
            If TypeOf shape Is DrawComponentShape Then
                Dim drawComponentShape As DrawComponentShape = CType(shape, DrawComponentShape)

                ' }i`擾
                Dim masterDrawComponent As MasterDrawComponent = drawComponentShape.Master

                ' }i`̖O擾
                Dim drawComponentName As String = masterDrawComponent.Name

                ' PRICEꍇ̃CfbNX擾
                Dim shapeAttributes As ShapeAttributeCollection = drawComponentShape.Attributes
                Dim index As Integer = shapeAttributes.IndexOfName("PRICE")
                If index >= 0 Then
                    ' zuĂ}iPRICEl擾
                    Dim shapeAttribute As ShapeAttribute = shapeAttributes(index) ' }i`̑ƓPRICẼCfbNXPRICEl擾
                    Dim priceText As String = shapeAttribute.Value ' zij
                    Dim price As Integer = Integer.Parse(priceText) ' z𐔒lɕϊ
                    Dim itemInfo() As Integer = New Integer(2) {}
                    ' WvpnbVe[uɍ}i`̖OL[ɂ݂̂ȏꍇ
                    If Not priceDict.TryGetValue(drawComponentName, itemInfo) Then
                        itemInfo = New Integer(1) {}
                        itemInfo(0) = 1 ' 
                        itemInfo(1) = price ' z
                        ' }i̖OL[ɐVl̒ǉ
                        priceDict.Add(drawComponentName, itemInfo)
                        ' ݂ꍇ͍XV
                    Else
                        itemInfo(0) = itemInfo(0) + 1 ' 
                        itemInfo(1) = itemInfo(1) + price ' z
                        priceDict(drawComponentName) = itemInfo
                    End If
                End If
            End If

            shape = drawing.Shapes.GetNextShape(shape) ' ̐}`
        End While

        ' }iȂꍇ͏I
        If priceDict.Count = 0 Then
            MessageBox.Show("ɁuPRICEvݒ肳ꂽ}izuĂ܂B")
            Return
        End If
        ' \̐ƕ}
        DrawListLineText(point, priceDict)
    End Sub

    ''' <summary>
    ''' \̐ƕ}
    ''' </summary>
    ''' <param name="locatePoint">\̔zu_()</param>
    ''' <param name="priceDict">WvpnbVe[u</param>
    ''' <remarks></remarks>
    Private Sub DrawListLineText(ByVal locatePoint As Point2d, ByVal priceDict As Dictionary(Of String, Integer()))

        Dim doc As Document = ActiveDocument
        Dim drawing As Drawing = doc.CurrentDrawing

        ' ̊l擾
        Dim textSettings As TextSettings = doc.TextSettings

        ' \̍s(ږ{}i̎ނ̐{vj
        Dim rowCount As Integer = 1 + priceDict.Count + 1

        ' \̗̐
        Const columnCount As Integer = 3

        ' ̍
        Dim textHeight As Double = textSettings.FontHeight

        ' 
        Dim columnWidth(columnCount - 1) As Double
        ' }iiږFij̕
        columnWidth(0) = 8 * textHeight ' 1̕ƓƂ8񕝂ɂ
        ' ̕
        columnWidth(1) = 3 * textHeight

        ' z̕
        columnWidth(2) = 5 * textHeight

        ' \Ŝ̕
        Dim listTotalWidth As Double = 0.0
        For i As Integer = 0 To columnCount - 1
            listTotalWidth += columnWidth(i)
        Next

        ' Z̃ItZbgl
        Dim offset As Double = textHeight * 0.2 ' 1Zɏ̗]
        ' Z̍
        Dim cellHight As Double = textHeight + offset * 2

        ' \Ŝ̍
        Dim listTotalHeight As Double = cellHight * rowCount

        ' UNDO \ȑJn
        doc.UndoManager.BeginUndoUnit()

        '' `(\̔zu_͍) 
        ' 
        For i As Integer = 0 To rowCount
            ' 
            Dim point1 As Point2d = Geometry.CreatePoint(locatePoint.X, locatePoint.Y - cellHight * i) ' n_
            Dim point2 As Point2d = Geometry.CreatePoint(locatePoint.X + listTotalWidth, locatePoint.Y - cellHight * i) ' I_
            Dim line As LineShape = drawing.Shapes.AddLine(point1, point2) ' ̒ǉ
            line.Linetype = doc.Linetypes.GetLinetypeByNumber(1) ' ()
        Next

        ' c
        Dim lastPointX As Double = 0.0
        For i As Integer = 0 To columnCount
            ' 
            Dim x As Double = 0.0
            If i = 0 Then
                x = locatePoint.X
            Else
                x = lastPointX + columnWidth((i - 1))
            End If
            Dim point1 As Point2d = Geometry.CreatePoint(x, locatePoint.Y) ' n_
            Dim point2 As Point2d = Geometry.CreatePoint(x, locatePoint.Y - listTotalHeight) ' I_
            Dim line As LineShape = drawing.Shapes.AddLine(point1, point2) ' ̒ǉ
            line.Linetype = doc.Linetypes.GetLinetypeByNumber(1) ' ()
            lastPointX = x
        Next


        '' Zɕ 
        Dim cellText(2) As String
        Dim textLocatePointX(2) As Double ' zu_XW1ځA2ځA3ځi1ڂ͍A2A3ڂ͉Ej
        textLocatePointX(0) = locatePoint.X + offset
        textLocatePointX(1) = locatePoint.X + columnWidth(0) + columnWidth(1) - offset
        textLocatePointX(2) = locatePoint.X + columnWidth(0) + columnWidth(1) + columnWidth(2) - offset

        ' ږs
        cellText(0) = "i" ' 1ځiij
        cellText(1) = "" ' 2ځij
        cellText(2) = "z" ' 3ځizj
        ' zu_YW
        Dim textLocatePointY As Double = locatePoint.Y - cellHight + offset
        ' o
        DrawPriceText(doc, drawing, cellText, textLocatePointX, textLocatePointY)

        ' iAAzivj̒l
        Dim totalPartsCount As Integer = 0
        Dim totalPrice As Integer = 0
        For Each key As String In priceDict.Keys
            Dim itemInfo As Integer() = priceDict(key)

            Dim partsCount As Integer = itemInfo(0) ' i̐
            Dim price As Integer = itemInfo(1) ' i̋zivj
            ' vlXV
            totalPartsCount += partsCount
            totalPrice += price

            ' 
            cellText(0) = key ' 1ځiij
            cellText(1) = partsCount.ToString() ' 2ځij
            cellText(2) = price.ToString() ' 3ځizj
            ' YW
            textLocatePointY -= cellHight

            ' o
            DrawPriceText(doc, drawing, cellText, textLocatePointX, textLocatePointY)
        Next key

        ' vs
        ' 
        cellText(0) = "v" ' 1ځiij
        cellText(1) = totalPartsCount.ToString() ' 2ځij
        cellText(2) = totalPrice.ToString() ' 3ځizj
        ' YW
        textLocatePointY -= cellHight

        ' o
        DrawPriceText(doc, drawing, cellText, textLocatePointX, textLocatePointY)

        ' UNDO \ȑI
        doc.UndoManager.EndUndoUnit()

    End Sub

    ''' <summary>
    ''' \̕1s
    ''' </summary>
    ''' <param name="doc"></param>
    ''' <param name="drawing"></param>
    ''' <param name="textLine">̔z(3)</param>
    ''' <param name="textLocatePointX">zu_XW</param>
    ''' <param name="textLocatePointY">zu_YW</param>
    ''' <remarks></remarks>
    Private Sub DrawPriceText(ByVal doc As Document, ByVal drawing As Drawing, ByVal textLine As String(), ByVal textLocatePointX As Double(), ByVal textLocatePointY As Double)
        Dim textShape As TextShape
        Dim textLocatePoint As Point2d = Geometry.CreatePoint(0.0, textLocatePointY)

        ' 1
        textLocatePoint.X = textLocatePointX(0)
        textShape = drawing.Shapes.AddText(textLine(0), textLocatePoint, 0)
        textShape.Color = doc.Colors.GetColorByNumber(1) ' F()
        textShape.Alignment = Alignment.BottomLeft ' 
        ' 2
        textLocatePoint.X = textLocatePointX(1)
        textShape = drawing.Shapes.AddText(textLine(1), textLocatePoint, 0)
        textShape.Color = doc.Colors.GetColorByNumber(1) ' F()
        textShape.Alignment = Alignment.BottomRight ' E
        ' 3
        textLocatePoint.X = textLocatePointX(2)
        textShape = drawing.Shapes.AddText(textLine(2), textLocatePoint, 0)
        textShape.Color = doc.Colors.GetColorByNumber(1) ' F()
        textShape.Alignment = Alignment.BottomRight ' E

    End Sub

End Class
